# Stack4Things IoTronic (standalone version)

Stack4Things is an Internet of Things framework developed by the Mobile and Distributed Systems Lab (MDSLab) at the University of Messina, Italy. Stack4Things is an open source project that helps you in managing IoT device fleets without caring about their physical location, their network configuration, their underlying technology. It is a Cloud-oriented horizontal solution (integrated with OpenStack) providing IoT object virtualization, customization, and orchestration. Stack4Things provides you with an out-of-the-box experience on several of the most popular embedded and mobile systems.

More details about Stack4Things can be found [here](https://github.com/MDSLab/stack4things).

IoTronic is the Cloud-side component in the Stack4Things architecture. In this repository, you find the standalone version of the IoTronic. It works with the version of the Lightining-rod probe that you can find [here] (https://github.com/MDSLab/s4t-lightning-rod).

IoTronic (in the standalone version) has been tested to work on:

* Ubuntu 16.04 
* Ubuntu 14.04 

## Installation guides

* [Installation guide for Ubuntu 16.04](docs/installation_ubuntu_16.04.md)

* [Installation guide for Ubuntu 14.04](docs/installation_ubuntu_14.04.md)

If you want to install IoTronic within an LXD container, you can find a guide [here](docs/installation_lxd.md).
